<?php

/**
 * @file
 */

function uc_netcash_complete($cart_id = 0) {
  list($orderid, $random) = explode("_", $_REQUEST["Reference"]);
  $order = uc_order_load($orderid);

  /**
   * Data callback from Netcash, hence $_POST
   */

  if (isset($_POST["TransactionAccepted"])) {
    // exit if we can't find the order
    if ($order === FALSE) {
      watchdog('netcash', 'Couldn\'t find order !reference.', array('!reference' => check_plain($_POST['Reference'])));
      exit(t('Your order could not be found. Please contact us to finalise your purchase.'));
    // log the order notification
    } else {
      watchdog('netcash', 'Receiving new order notification for order !order_id.', array('!order_id' => $order->order_id));
    }

    // check that transaction was accepted and callback is coming from Netcash's server
    // http_x_forwarded_for is needed - don't remove!
    if ($_POST['TransactionAccepted'] == "true") {
      uc_payment_enter($order->order_id, 'netcash', $_POST['Amount'], $order->uid, null, "");
    }
  }

  /**
   * Redirect from Netcash, hence $_GET
   */

  // show payment success/failure
  if (isset($_GET["TransactionAccepted"])) {
    if ($_GET['TransactionAccepted'] == "true") {
      drupal_set_message(t('Your payment was successful. Thank you!'));
    } else {
      drupal_set_message(t('Your payment was NOT successful. Please try again later or choose a different payment method.'));
    }
  }

  // Empty the cart, irrespective of _GET or _POST,
  // because order exists now
  if ($_REQUEST['TransactionAccepted'] == "true") {
    uc_cart_empty($cart_id);
  }

  // redirect
  if ($_REQUEST['TransactionAccepted'] == "true") {
    // redirect if cart setup to do that
    $page = variable_get('uc_cart_checkout_complete_page', '');
    if (!empty($page)) {
      drupal_goto($page);
    }
    // otherwise just show order complete
    $output = uc_cart_complete_sale($order, variable_get('uc_new_customer_login', FALSE));
    return $output;
  } else {
    drupal_goto("cart");
  }
}